/**
 * 今後ポートされる予定の汎用的な関数群
 */
/**
 * Function used to assert a given code path is unreachable
 */
export declare function unreachable(): never;
/**
 * Function used to assert a given code path is unreachable.
 * Very useful for ensuring switches are exhaustive:
 *
 * ```ts
 * switch (a.type) {
 *   case Types.A:
 *   case Types.B:
 *     break
 *   default:
 *     unreachable(a) // will cause a build error if there was
 *                    // a Types.C that was not checked
 * }
 * ```
 *
 * @param value Value to be asserted as unreachable
 */
export declare function unreachable(value: never): never;
/**
 * 複数のrefをマージする。
 *
 * forwardRefで受け取ったrefと、コンポーネント内で定義したrefを同じ要素につけたいケースなどで使う
 */
export declare function mergeRefs<T>(...refs: React.Ref<T>[]): React.RefCallback<T>;
export declare function countCodePointsInString(string: string): number;
//# sourceMappingURL=index.d.ts.map