import './index.css';
import React, { ReactNode, type JSX } from 'react';
type Variant = 'Primary' | 'Default' | 'Overlay' | 'Danger' | 'Navigation';
type Size = 'S' | 'M';
export type ButtonProps<T extends React.ElementType = 'button'> = {
    children?: ReactNode;
    variant?: Variant;
    size?: Size;
    fullWidth?: boolean;
    isActive?: boolean;
    /**
     * The component used for root element.
     * @type T extends React.ElementType = 'button'
     */
    component?: T;
} & Omit<React.ComponentPropsWithRef<T>, 'children'>;
declare const Button: <T extends React.ElementType<any, keyof JSX.IntrinsicElements> = "button">(p: "button" extends T ? ButtonProps<"button"> : {
    children?: ReactNode;
    variant?: Variant | undefined;
    size?: Size | undefined;
    fullWidth?: boolean | undefined;
    isActive?: boolean | undefined;
    /**
     * The component used for root element.
     * @type T extends React.ElementType = 'button'
     */
    component?: T | undefined;
} & Omit<React.ComponentPropsWithRef<T>, "children"> & {
    component: T;
}) => JSX.Element;
export default Button;
//# sourceMappingURL=index.d.ts.map