import './index.css';
import { RefObject, ReactNode } from 'react';
export type PopoverProps = {
    isOpen: boolean;
    onClose: () => void;
    children: ReactNode;
    triggerRef: RefObject<Element | null>;
    popoverRef?: RefObject<HTMLDivElement | null>;
};
/**
 * 画面の全面に動的に開くことができるコンテナ要素
 * 外の要素をクリックしたり、内部からフォーカスを移動した場合に自動的に閉じる
 *
 * triggerRefの付近に画面内に収まるように表示される
 */
export default function Popover(props: PopoverProps): import("react/jsx-runtime").JSX.Element | null;
//# sourceMappingURL=index.d.ts.map