import React, { type JSX } from 'react';
import type { KnownIconType } from '@charcoal-ui/icons';
import './index.css';
type Variant = 'Default' | 'Overlay';
type Size = 'XS' | 'S' | 'M';
export type IconButtonProps<T extends React.ElementType = 'button'> = {
    readonly variant?: Variant;
    readonly size?: Size;
    readonly icon: keyof KnownIconType;
    readonly isActive?: boolean;
    component?: T;
} & Omit<React.ComponentPropsWithRef<T>, 'children' | 'as'>;
declare const IconButton: <T extends React.ElementType<any, keyof JSX.IntrinsicElements> = "button">(p: IconButtonProps<T>) => JSX.Element;
export default IconButton;
//# sourceMappingURL=index.d.ts.map