import * as React from 'react';
import type { AriaDialogProps } from '@react-types/dialog';
import { ButtonProps } from '../Button';
import { IconButtonProps } from '../IconButton';
import { CharcoalModalOverlayProps } from './useCustomModalOverlay';
import './index.css';
export type BottomSheet = boolean | 'full';
export type Size = 'S' | 'M' | 'L';
export type ModalProps = CharcoalModalOverlayProps & AriaDialogProps & {
    children: React.ReactNode;
    zIndex?: number;
    title: string;
    size?: Size;
    bottomSheet?: BottomSheet;
    isOpen: boolean;
    onClose: () => void;
    className?: string;
    closeButtonAriaLabel?: string;
    /**
     * https://github.com/adobe/react-spectrum/issues/3787
     * Next.jsで使用する際に発生するエラーの一時的な回避策でdocument.bodyを指定する必要がある
     */
    portalContainer?: HTMLElement;
};
declare const _default: React.MemoExoticComponent<React.ForwardRefExoticComponent<import("@react-aria/overlays").AriaModalOverlayProps & {
    overflowClip?: boolean | undefined;
} & AriaDialogProps & {
    children: React.ReactNode;
    zIndex?: number | undefined;
    title: string;
    size?: Size | undefined;
    bottomSheet?: BottomSheet | undefined;
    isOpen: boolean;
    onClose: () => void;
    className?: string | undefined;
    closeButtonAriaLabel?: string | undefined;
    /**
     * https://github.com/adobe/react-spectrum/issues/3787
     * Next.jsで使用する際に発生するエラーの一時的な回避策でdocument.bodyを指定する必要がある
     */
    portalContainer?: HTMLElement | undefined;
} & React.RefAttributes<HTMLDivElement>>>;
export default _default;
export declare const ModalContext: React.Context<{
    /**
     * @deprecated
     */
    titleProps: React.HTMLAttributes<HTMLElement>;
    title: string;
    close?: (() => void) | undefined;
    showDismiss: boolean;
    bottomSheet: BottomSheet;
}>;
export declare function ModalCloseButton(props: Omit<IconButtonProps, 'icon'>): import("react/jsx-runtime").JSX.Element;
export declare function ModalDismissButton({ children, ...props }: ButtonProps): import("react/jsx-runtime").JSX.Element | null;
//# sourceMappingURL=index.d.ts.map