import * as React from 'react';
import { AriaModalOverlayProps, ModalOverlayAria } from '@react-aria/overlays';
/**
 * We want to enable scrolling on the modal background,
 * but `useModalOverlay` (specifically, `useOverlay` within it) detects pointer events on the scrollbar.
 * Therefore, to prevent this issue, we need to override `shouldCloseOnInteractOutside` in `useModalOverlay`.
 */
export type CharcoalModalOverlayProps = AriaModalOverlayProps & {
    overflowClip?: boolean;
};
export declare function useCharcoalModalOverlay(props: CharcoalModalOverlayProps, state: {
    isOpen: boolean;
    onClose: () => void;
}, ref: React.RefObject<HTMLElement | null>): ModalOverlayAria;
export declare function useWindowWidth(): number | null;
//# sourceMappingURL=useCustomModalOverlay.d.ts.map